<?php

echo '<p><b>Mise à jour de la base de données <i class="fas fa-angle-double-right"></i> Version 0.44</b></p>
<ul class="maxwidth">';

// Ajout d'un visualisation d\'anniversaire dans le module fréquentation
if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_parametres WHERE param_nom = 'freq_birthday_img'"))==0) {
	mysqli_query($bdd,"INSERT INTO ".$prefix."_parametres (param_id, param_nom, valeur, comments) VALUES ('', 'freq_birthday_img', '0', 'Option de visualisation d\'anniversaire dans le module fréquentation.')");
}
echo '<li>Ajout d\'un paramètre de visualisation d\'anniversaire dans le module fréquentation.</li>';

// Ajout d'un paramètre d\'avertissement sonore en cas d\'anniversaire dans le module fréquentation
if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_parametres WHERE param_nom = 'freq_birthday_bip'"))==0) {
	mysqli_query($bdd,"INSERT INTO ".$prefix."_parametres (param_id, param_nom, valeur, comments) VALUES ('', 'freq_birthday_bip', '0', 'Option d\'avertissement sonore en cas d\'anniversaire dans le module fréquentation.')");
}
echo '<li>Ajout d\'un paramètre d\'avertissement sonore en cas d\'anniversaire dans le module fréquentation.</li>';

// Ajout d'un paramètre d\'avertissement sonore en cas de passage d'un seuil de fréquentation
if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_parametres WHERE param_nom = 'freq_nbvisites_bip'"))==0) {
	mysqli_query($bdd,"INSERT INTO ".$prefix."_parametres (param_id, param_nom, valeur, comments) VALUES ('', 'freq_nbvisites_bip', '0', 'Option d\'avertissement sonore en cas de passage d\'un seuil de fréquentation.')");
}
echo '<li>Ajout d\'un paramètre d\'avertissement sonore en cas de passage d\'un seuil de fréquentation.</li>';

// Recréation de la table _savchamps

$champs = mysqli_query($bdd,"SELECT * FROM ".$prefix."_savchamps WHERE champs_id = 'CE01' OR champs_id = 'CP02' OR champs_id = 'CR03' OR champs_id = 'CT04' ORDER BY champs_id ASC");
$colors = array();
foreach($champs as $champ) {
	array_push($colors, $champ['bgcolor']);
}
$testemi = mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_savchamps WHERE champs_id = 'AU01'"));
if($testemi>0) {
	$champs = mysqli_query($bdd,"SELECT * FROM ".$prefix."_savchamps WHERE champs_id = 'AU01' OR champs_id = 'EX02' OR champs_id = 'ME03' OR champs_id = 'PR04' ORDER BY champs_id ASC");
	foreach($champs as $champ) {
		array_push($colors, $champ['bgcolor']);
	}
}
else {
	array_push($colors, '#CEF6CE');
	array_push($colors, '#F5F6CE');
	array_push($colors, '#CECEF6');
	array_push($colors, '#F6CED8');
}

$testchs = mysqli_query($bdd,"SELECT * FROM ".$prefix."_savchamps WHERE champs_id <> 'CE01' AND champs_id <> 'CP02' AND champs_id <> 'CR03' AND champs_id <> 'CT04' AND champs_id <> 'AU01' AND champs_id <> 'EX02' AND champs_id <> 'ME03' AND champs_id <> 'PR04'");
$pers_id = array();
$pers_na = array();
$pers_bg = array();
foreach($testchs as $testch) {
	array_push($pers_id, $testch['champs_id']);
	array_push($pers_na, $testch['champs_nom']);
	array_push($pers_bg, $testch['bgcolor']);
}

mysqli_query($bdd,"DROP TABLE IF EXISTS ".$base.".".$prefix."_savchamps");

mysqli_query($bdd,"CREATE TABLE IF NOT EXISTS ".$base.".".$prefix."_savchamps (sc_id INT ( 11 ) NOT NULL AUTO_INCREMENT , champs_id VARCHAR ( 10 ) COLLATE utf8_unicode_ci NOT NULL , champs_nom TEXT COLLATE utf8_unicode_ci DEFAULT NULL , bgcolor VARCHAR ( 7 ) COLLATE utf8_unicode_ci DEFAULT NULL, PRIMARY KEY ( sc_id ) ) ENGINE = MYISAM DEFAULT CHARSET = utf8 COLLATE = utf8_unicode_ci;");

$ce01_s = 'Environnements informationnels et numériques';
$ce01 = mysqli_real_escape_string($bdd,$ce01_s);
$cp02_s = 'Processus d\'information et de documentation';
$cp02 = mysqli_real_escape_string($bdd,$cp02_s);
$cr03_s = 'Recul critique sur les médias, les TIC et l\'information';
$cr03 = mysqli_real_escape_string($bdd,$cr03_s);
$ct04_s = 'Responsabilité légale et éthique relative à l\'information';
$ct04 = mysqli_real_escape_string($bdd,$ct04_s);
$au01_s = 'Utiliser les médias et les informations de manière autonome';
$au01 = mysqli_real_escape_string($bdd,$au01_s);
$ex02_s = 'Exploiter l\'information de manière raisonnée';
$ex02 = mysqli_real_escape_string($bdd,$ex02_s);
$me03_s = 'Utiliser les médias de manière responsable';
$me03 = mysqli_real_escape_string($bdd,$me03_s);
$pr04_s = 'Produire, communiquer, partager des informations';
$pr04 = mysqli_real_escape_string($bdd,$pr04_s);
mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('CE01', '".$ce01."', '".$colors[0]."')");
mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('CP02', '".$cp02."', '".$colors[1]."')");
mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('CR03', '".$cr03."', '".$colors[2]."')");
mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('CT04', '".$ct04."', '".$colors[3]."')");
mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('AU01', '".$au01."', '".$colors[4]."')");
mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('EX02', '".$ex02."', '".$colors[5]."')");
mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('ME03', '".$me03."', '".$colors[6]."')");
mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('PR04', '".$pr04."', '".$colors[7]."')");

for($i=0;$i<count($pers_id);$i++) {
	mysqli_query($bdd,"INSERT INTO ".$prefix."_savchamps (champs_id, champs_nom, bgcolor) VALUES ('".$pers_id[$i]."', '".$pers_na[$i]."', '".$pers_bg[$i]."')");
}
echo '<li>Recréation de la table _savchamps.</li>';

// Suppression de fichiers obsolètes :
$ouverture = opendir("./js/idl/");
$lecture = readdir($ouverture);
$filename = './js/idl/param_effectifs.php';
if (file_exists($filename)) {
	unlink ("./js/idl/param_effectifs.php");
}
closedir($ouverture);
$ouverture = opendir("./db/proc/");
$lecture = readdir($ouverture);
$filename = './db/proc/acadchoix.php';
if (file_exists($filename)) {
	unlink ("./db/proc/acadchoix.php");
}
closedir($ouverture);
echo '<li>Suppression du fichier obsolète /js/idl/param_effectifs.php.</li>';
echo '<li>Suppression du fichier obsolète /db/proc/acadchoix.php.</li>';

mkdir("./db/backup/".$prefix, 0705);
mkdir("./img/edt/".$prefix, 0705);
mkdir("./img/wav/".$prefix, 0705);
mkdir("./seqfichiers/".$prefix, 0705);
mkdir("./xml/".$prefix, 0705);
echo '<li>Création de dossiers spécifiques de gestion des documents créés ou ajoutés dans le logiciel (vers /db/backup/, /img/edt/, /img/wav/, /seqfichiers/, /xml/)</li>';

$destination = './db/backup/'.$prefix.'/';
if($dossier = opendir('./db/backup')) {
	while(false !== ($fichier = readdir($dossier))) {
		if($fichier != '.' && $fichier != '..' && $fichier != $prefix && !is_file($fichier)) {
			$rename_file = $destination.$fichier;
    		rename('./db/backup/'.$fichier, $rename_file);
		}
	}
}
closedir($dossier);
$destination = './img/edt/'.$prefix.'/';
if($dossier = opendir('./img/edt')) {
	while(false !== ($fichier = readdir($dossier))) {
		if($fichier != '.' && $fichier != '..' && $fichier != $prefix && !is_file($fichier)) {
			$rename_file = $destination.$fichier;
    		rename('./img/edt/'.$fichier, $rename_file);
		}
	}
}
closedir($dossier);
$destination = './img/wav/'.$prefix.'/';
if($dossier = opendir('./img/wav')) {
	while(false !== ($fichier = readdir($dossier))) {
		if($fichier != '.' && $fichier != '..' && $fichier != $prefix && $fichier != '0227.wav' && $fichier != '0253.wav' && $fichier != '0283.wav' && $fichier != '0292.wav' && $fichier != '0294.wav' && $fichier != '0863.wav' && $fichier != '0899.wav' && $fichier != '0236.wav' && $fichier != '2481.wav' && !is_file($fichier)) {
			$rename_file = $destination.$fichier;
    		rename('./img/wav/'.$fichier, $rename_file);
		}
	}
}
closedir($dossier);
$destination = './seqfichiers/'.$prefix.'/';
if($dossier = opendir('./seqfichiers')) {
	while(false !== ($fichier = readdir($dossier))) {
		if($fichier != '.' && $fichier != '..' && $fichier != $prefix && !is_file($fichier)) {
			$rename_file = $destination.$fichier;
    		rename('./seqfichiers/'.$fichier, $rename_file);
		}
	}
}
closedir($dossier);
$destination = './xml/'.$prefix.'/';
if($dossier = opendir('./xml')) {
	while(false !== ($fichier = readdir($dossier))) {
		if($fichier != '.' && $fichier != '..' && $fichier != $prefix && !is_file($fichier)) {
			$rename_file = $destination.$fichier;
    		rename('./xml/'.$fichier, $rename_file);
		}
	}
}
closedir($dossier);

echo '<li>Transfert des fichiers, dans chaque cas, de l\'ancien dossier vers le nouveau dossier</li>';

// version bdd :
mysqli_query($bdd,"UPDATE ".$prefix."_parametres SET valeur = '0.44' WHERE param_nom = 'version_bdd'");
echo '<li>Mise à jour de la base de données effectuée - version_bdd 0.44.</li></ul>';
?>